SystemOrganization addCategory: #'CS528-UT3Base'!

TestCase subclass: #UT3BoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BoardTest commentStamp: '<historical>' prior: 0!
An UT3BoardTest is a class for holding test cases for the UT3Board.

Instance Variables
!

UT3BoardTest subclass: #UT3BasicBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 11:55'!
testCreateEmptyBoard
	|board|
	board := UT3BasicBoard new.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'Oliver 7/21/2013 05:15'!
testCreateEmptyBoard2
	|board|
	board := UT3BasicBoard new.
	board size: 5.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'Oliver 7/21/2013 05:15'!
testCreateEmptyBoard3
	|board|
	board := UT3BasicBoard new.
	board size: 7.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'Oliver 7/21/2013 05:15'!
testCreateEmptyBoard4
	|board|
	board := UT3BasicBoard new.
	board size: 9.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'Oliver 7/21/2013 05:15'!
testCreateEmptyBoard5
	|board|
	board := UT3BasicBoard new.
	board size: 11.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'Oliver 7/21/2013 05:15'!
testCreateEmptyBoard6
	|board|
	board := UT3BasicBoard new.
	board size: 13.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'Oliver 7/21/2013 05:15'!
testCreateEmptyBoard7
	|board|
	board := UT3BasicBoard new.
	board size: 15.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'JonathanOsting 7/22/2013 21:27'!
testPlayOneGameWithColumnWinner
	|board|
	board := UT3BasicBoard new.
	board at: #(1 1) put: #circle.
	board at: #(1 2) put: #cross.
	board at: #(2 1) put: #circle.
	board at: #(2 2) put: #cross.
	board at: #(3 3) put: #circle.
	board at: #(3 2) put: #cross.
	self assert: board movesCount equals: 6.
	self assert: board winner equals: #cross.
	"Cannot change the winner once it's set!!"
	board at: #(3 1) put: #circle.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'JonathanOsting 7/22/2013 21:33'!
testPlayOneGameWithDiagonalWinner
	|board|
	board := UT3BasicBoard new.
	board at: #(1 1) put: #cross.
	board at: #(2 1) put: #circle.
	board at: #(2 2) put: #cross.
	board at: #(3 1) put: #circle.
	board at: #(3 3) put: #cross.
	self assert: board movesCount equals: 5.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'JonathanOsting 7/22/2013 21:34'!
testPlayOneGameWithRowWinner
	|board|
	board := UT3BasicBoard new.
	board at: #(1 1) put: #cross.
	board at: #(1 2) put: #circle.
	board at: #(2 1) put: #cross.
	board at: #(1 3) put: #circle.
	board at: #(3 1) put: #cross.
	self assert: board movesCount equals: 5.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'JonathanOsting 7/22/2013 21:37'!
testWinnerChecks
	|board|
	"Win by row"
	1 to: 3 do: [ :column | 
		board := UT3BasicBoard new.
		board at: {1 . column} put: #cross.
		board at: {2 . column} put: #cross.
		board at: {3 . column} put: #cross.
		self assert: board movesCount equals: 3.
		self assert: board winner equals: #cross.
	].
	Transcript show: board printString.
	
	"Win by column"
	1 to: 3 do: [ :row | 
		board := UT3BasicBoard new.
		board at: {row . 1} put: #circle.
		board at: {row . 2} put: #circle.
		board at: {row . 3} put: #circle.
		self assert: board movesCount equals: 3.
		self assert: board winner equals: #circle.
	].
	Transcript show: board printString.

	"Win by top left to bottom right diagonal"
	board := UT3BasicBoard new.
	1 to: 3 do: [ :index | board at: {index . index} put: #cross].
	self assert: board movesCount equals: 3.
	self assert: board winner equals: #cross.
		Transcript show: board printString.

	board := UT3BasicBoard new.
		1 to: 3 do: [ :index | board at: {index . ( 3 - index + 1 )} put: #circle].
	self assert: board movesCount equals: 3.
	self assert: board winner equals: #circle.
		Transcript show: board printString.
! !

UT3BoardTest subclass: #UT3Connect4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Connect4Test methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:00'!
testColumnWinner
	| board |
	board := UT3Connect4Board new.
	1 to: 3 do: [ :i | 
		board at: 1 put: #circle.
		self assert: (board movesCount = i).
		"	self deny: (board winner = #circle)."
		self deny: (board winner = #cross).
		self assert: (board winner = #undecided).
	].
	board at: 1 put: #circle.
	self assert: (board movesCount = 4).
	self assert: (board winner = #circle).
	"Cannot change the winner once it's set!!"
	1 to: 4 do: [ :i | 
		board at: 2 put: #cross.
		self assert: (board movesCount = (i+4)).
		self deny: (board winner = #cross).
		self assert: (board winner = #circle).
	].
	Transcript open; show: board printBoardString.! !

!UT3Connect4Test methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:48'!
testIsFull
	| board |
	board := UT3Connect4Board new.
	(1 to: board size first) do: [ :aRow |
		(1 to: board size second) do: [ :aCol |
			board at: aCol put: #circle.
			(aRow = board size first & aCol = board size second )
			ifTrue: [self assert: (board isFull) ]
			ifFalse: [ self deny: (board isFull) ]
	] ].
	Transcript open; show: board printBoardString.! !

!UT3Connect4Test methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:41'!
testLeftDiagonalWinner
	| board |
	board := UT3Connect4Board new.
	1 to: 3 do: [ :i | 
		board at: 2 put: #cross.
		(i < 3) ifTrue: [ board at: 3 put: #cross ].
		(i < 2) ifTrue: [ board at: 4 put: #cross ].
		"	self deny: (board winner = #circle)."
		self deny: (board winner = #cross).
		self assert: (board winner = #undecided).
	].
	"Cannot change the winner once it's set!!"
	2 to: 5 do: [ :i | 
		board at: i put: #circle.
		self deny: (board winner = #cross).
	].
	self assert: (board winner = #circle).
	Transcript open; show: board printBoardString.! !

!UT3Connect4Test methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/22/2013 22:58'!
testPrintBoardString
	| board1  |
	board1 := UT3Connect4Board new.
	board1 at: 1 put: #circle.
	board1 at: 2 put: #cross.
	board1 at: 3 put: #circle.
	board1 at: 4 put: #cross.
	board1 at: 5 put: #circle.
	board1 at: 6 put: #cross.
	
	board1 at: 3 put: #circle.
	board1 at: 4 put: #cross.
	board1 at: 5 put: #circle.
	board1 at: 6 put: #cross.
	board1 at: 7 put: #circle.
	board1 at: 3 put: #cross.
	
	Transcript open; show: board1 printBoardString.! !

!UT3Connect4Test methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:42'!
testRightDiagonalWinner
	| board |
	board := UT3Connect4Board new.
	1 to: 3 do: [ :i | 
		board at: 4 put: #cross.
		(i < 3) ifTrue: [ board at: 3 put: #cross ].
		(i < 2) ifTrue: [ board at: 2 put: #cross ].
		"	self deny: (board winner = #circle)."
		self deny: (board winner = #cross).
		self assert: (board winner = #undecided).
	].
	"Cannot change the winner once it's set!!"
	1 to: 4 do: [ :i | 
		board at: i put: #circle.
		self deny: (board winner = #cross).
	].
	self assert: (board winner = #circle).
	Transcript open; show: board printBoardString.! !

!UT3Connect4Test methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 21:50'!
testRowWinner
	| board |
	board := UT3Connect4Board new.
	1 to: 3 do: [ :i | 
		board at: i put: #circle.
		self assert: (board movesCount = i).
		"	self deny: (board winner = #circle)."
		self deny: (board winner = #cross).
		self assert: (board winner = #undecided).
	].
	board at: 4 put: #circle.
	self assert: (board movesCount = 4).
	self assert: (board winner = #circle).
	"Cannot change the winner once it's set!!"
	1 to: 5 do: [ :i | 
		board at: i put: #cross.
		self assert: (board movesCount = (i+4)).
		self deny: (board winner = #cross).
		self assert: (board winner = #circle).
	].
	Transcript open; show: board printBoardString.! !

UT3BoardTest subclass: #UT3GomokuBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3GomokuBoardTest methodsFor: 'tests' stamp: 'Oliver 7/25/2013 16:39'!
testCreateEmptyBoard
	|board|
	board := UT3GomokuBoard new.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3GomokuBoardTest methodsFor: 'tests' stamp: 'Oliver 7/25/2013 16:40'!
testCreateEmptyBoard2
	|board|
	board := UT3GomokuBoard new.
	board size: 5.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3GomokuBoardTest methodsFor: 'tests' stamp: 'Oliver 7/25/2013 16:40'!
testCreateEmptyBoard3
	|board|
	board := UT3GomokuBoard new.
	board size: 7.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3GomokuBoardTest methodsFor: 'tests' stamp: 'Oliver 7/25/2013 16:40'!
testCreateEmptyBoard4
	|board|
	board := UT3GomokuBoard new.
	board size: 9.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3GomokuBoardTest methodsFor: 'tests' stamp: 'Oliver 7/25/2013 16:40'!
testCreateEmptyBoard5
	|board|
	board := UT3GomokuBoard new.
	board size: 11.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3GomokuBoardTest methodsFor: 'tests' stamp: 'Oliver 7/25/2013 16:40'!
testCreateEmptyBoard6
	|board|
	board := UT3GomokuBoard new.
	board size: 13.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3GomokuBoardTest methodsFor: 'tests' stamp: 'Oliver 7/25/2013 16:40'!
testCreateEmptyBoard7
	|board|
	board := UT3GomokuBoard new.
	board size: 15.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

UT3BoardTest subclass: #UT3NestedBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/25/2013 21:12'!
testColumnVictories
	| board |
	board := UT3NestedBoard new.
	board at: { 1. 1 . 1. 1 } put: #circle.
	board at: { 1. 1 . 2. 1 } put: #circle.
	board at: { 2. 1 . 1. 1 } put: #circle.
	board at: { 1. 1 . 3. 1 } put: #circle.
	board at: { 3. 1 . 2. 1 } put: #circle.
	board at: { 2. 1 . 2. 1 } put: #circle.
	board at: { 2. 1 . 3. 1 } put: #circle.
	board at: { 3. 1 . 3. 1 } put: #circle.
	board at: { 3. 1 . 1. 1 } put: #circle.
	Transcript open; show: board printBoardString.
	self assert: board winner equals: #circle! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/25/2013 21:16'!
testDiagonalVictories
	|board |
	"Top left to bottom right"
	board := UT3NestedBoard new.
	board at: { 1. 1 . 1. 1 } put: #circle.
	board at: { 1. 1 . 2. 2 } put: #circle.
	board at: { 2. 2 . 2. 2 } put: #circle.
	board at: { 2. 2 . 1. 1 } put: #circle.
	board at: { 1. 1 . 3. 3 } put: #circle.
	board at: { 3. 3 . 3. 3 } put: #circle.
	board at: { 3. 3 . 2. 2 } put: #circle.
	board at: { 2. 2 . 3. 3 } put: #circle.
	board at: { 3. 3 . 1. 1 } put: #circle.
	Transcript open; show: board printBoardString .
	self assert: board winner equals: #circle.
	
	"Bottom left to top right"
	board := UT3NestedBoard new.
	board at: { 3. 1 . 3. 1 } put: #cross.
	board at: { 3. 1 . 2. 2 } put: #cross.
	board at: { 2. 2 . 2. 2 } put: #cross.
	board at: { 2. 2 . 3. 1 } put: #cross.
	board at: { 3. 1 . 1. 3 } put: #cross.
	board at: { 1. 3 . 1. 3 } put: #cross.
	board at: { 1. 3 . 2. 2 } put: #cross.
	board at: { 2. 2 . 1. 3 } put: #cross.
	board at: { 1. 3 . 3. 1 } put: #cross.
	self assert: board winner equals: #cross.
	Transcript open; show: board printBoardString ! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/8/2013 16:28'!
testOneGameRound
	| board |
	"End game result will look like
    |    |     ||     |    | x  ||  x | 0 |    
    | x |     ||     | x |     ||     |    | x 
    |    | 0  ||     |    |     ||     |    |    

    |    |     ||  0 | 0 | 0  ||     |    | 0 
 0 | 0 | 0  ||  x | x | x  ||  x | 0 |    
    |    |     ||     |    |     ||  0 |    |    

    |    |     ||     |    |     ||     |    |    
 x |    |     ||     |    |     ||     |    | x 
    |    |     ||     |    |     ||     |    |    

	Where the winner is Circle"
	board := UT3NestedBoard new.
	board at: { 2. 2 . 2. 2 } put: #cross.
	board at: { 2. 2 . 1. 2 } put: #circle.
	board at: { 1. 2 . 1. 3 } put: #cross.
	board at: { 1. 3 . 1. 2 } put: #circle.
	board at: { 1. 2 . 2. 2 } put: #cross.
	board at: { 2. 2 . 1. 1 } put: #circle.
	board at: { 1. 1 . 2. 2 } put: #cross.
	board at: { 2. 2 . 1. 3 } put: #circle.
	"Middle is won by circle"
	self assert: board winner equals: #undecided.
	board at: { 1. 3 . 2. 3 } put: #cross.
	board at: { 2. 3 . 2. 2 } put: #circle.
	board at: { 2. 2 . 2. 3 } put: #cross.
	board at: { 2. 3 . 1. 3 } put: #circle.
	board at: { 1. 3 . 1. 1 } put: #cross.
	board at: { 1. 1 . 3. 3 } put: #circle.
	board at: { 3. 3 . 2. 3 } put: #cross.
	board at: { 2. 3 . 3. 1 } put: #circle.
	"Middle right won by circle"
	self assert: board winner equals: #undecided.
	board at: { 3. 1 . 2. 1 } put: #cross.
	board at: { 2. 1 . 2. 2 } put: #circle.
	board at: { 2. 2 . 2. 1 } put: #cross.
	board at: { 2. 1 . 2. 3 } put: #circle.
	board at: { 2. 3 . 2. 1 } put: #cross.
	board at: { 2. 1 . 2. 1 } put: #circle.
	self assert: board winner equals: #circle.
	Transcript open; show: board.! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/23/2013 23:05'!
testPrintBoardString
	| board1  |
	board1 := UT3NestedBoard new.
	board1 at: (Array with: 1 with: 1 with: 1 with: 1) put: #circle.
	board1 at: (Array with: 1 with: 1 with: 3 with: 3) put: #cross.
	board1 at: (Array with: 3 with: 3 with: 2 with: 1) put: #circle.
	board1 at: (Array with: 2 with: 1 with: 1 with: 2) put: #cross.
	board1 at: (Array with: 1 with: 2 with: 3 with: 2) put: #circle.
	board1 at: (Array with: 3 with: 2 with: 2 with: 3) put: #cross.
	Transcript open; show: board1 printBoardString.! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/25/2013 21:09'!
testRowVictories
	| board |
	board := UT3NestedBoard new.
	board at: { 1. 1 . 1. 1 } put: #cross.
	board at: { 1. 1 . 1. 2 } put: #cross.
	board at: { 1. 2 . 1. 1 } put: #cross.
	board at: { 1. 1 . 1. 3 } put: #cross.
	board at: { 1. 3 . 1. 1 } put: #cross.
	board at: { 1. 1 . 2. 2 } put: #cross.
	board at: { 2. 2 . 1. 2 } put: #cross.
	board at: { 1. 2 . 1. 2 } put: #cross.
	board at: { 1. 2 . 1. 3 } put: #cross.
	board at: { 1. 3 . 1. 3 } put: #cross.
	board at: { 1. 3 . 1. 2 } put: #cross.
	Transcript open; show: board printBoardString.
	self assert: board winner equals: #cross! !

TestCase subclass: #UT3SystemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/23/2013 23:22'!
testInitializeBasic
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system player: 1 moveAt: #(1 1).
	self assert: system currentPlayer equals: 2.! !

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/23/2013 23:22'!
testInitializeBasicWithAI
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system resetWithGameType: #basic ai: #random.	
	system player: 1 moveAt: #(1 1).
	"After move, the AI will move immediately."
	self assert: system currentPlayer equals: 1.! !

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 19:13'!
testInitializeUltimate
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system resetWithGameType: #ultimate.
	system player: 1 moveAt: { 1. 1 } subBoard: { 1. 1 }.
	self assert: system currentPlayer equals: 2.! !

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 01:52'!
testInitializeUltimateWithAI
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system resetWithGameType: #ultimate ai: #random.	
	system player: 1 moveAt: { 1. 1 } subBoard: { 1. 1 }.
	self assert: system currentPlayer equals: 1.! !

Error subclass: #MoveError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!MoveError commentStamp: '<historical>' prior: 0!
A MoveError is an Error that is throw when an invalid move happens.

Instance Variables
!

Error subclass: #SystemError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!SystemError commentStamp: '<historical>' prior: 0!
A SystemError is an Error encountered within the System.

Instance Variables
!

Object subclass: #UT3Board
	instanceVariableNames: 'size movesCount winner matrix winningCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Board commentStamp: '<historical>' prior: 0!
An UT3Board is a board.

Instance Variables

Here are a few quick reason about why I code them that way and 

what are those magic numbers stand for.

First, the board(boardMatrix in the code) is a 9 * 9 matrix they actually don't need to be nested(although they could) because we could access it really convenient by rows and columns and we could submatrix whenever we want. 
(here is a handy list of matrix functions http://magaloma.seasidehosting.st/Collections-Unordered)

Each cell in the board, say 1 out of 81, has three status: 

0: not played yet. 
1: player 1 marked. 
2: player 2 taken. 

That boardGlobalMatrix is 3 * 3 and design to mark the winning status of the small board, 
it changes and only changes when one (of the two players) win a subarea.   
It is a global marker with global winning status overview... so is named with 'global' in it. !

UT3Board subclass: #UT3BasicBoard
	instanceVariableNames: 'isFull'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BasicBoard commentStamp: '<historical>' prior: 0!
An UT3BasicBoard is a basic Tic Tac Toe board.
With it, you can play a normal 3 x 3 Tic Tac Toe game.

Instance Variables
	cellMatrix:		<Object>
	isFull:		<Object>
	movesCount:		<Object>
	size:		<Object>
	winner:		<Object>

cellMatrix
	- xxxxx

isFull
	- xxxxx

movesCount
	- xxxxx

size
	- xxxxx

winner
	- xxxxx
!

!UT3BasicBoard class methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:04'!
newWithSize: anInteger
	^ self new resetWithSize: anInteger! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:26'!
= aBasicBoard
	^ winner = aBasicBoard winner! !

!UT3BasicBoard methodsFor: 'public' stamp: 'JonathanOsting 7/23/2013 19:51'!
at: aRow at: aColumn
	^ matrix at: aRow at: aColumn! !

!UT3BasicBoard methodsFor: 'public' stamp: 'JonathanOsting 7/23/2013 19:52'!
at: coordsArray put: aSymbol 
	| cell |
	coordsArray size ~= 2 ifTrue: [ MoveError signal: 'Invalid coords array.' ].
	self isFull ifTrue: [ MoveError signal: 'Board is full.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	cell := matrix at: coordsArray first at: coordsArray second.
	cell state = #empty ifFalse: [ MoveError signal: 'Cell already filled.' ].
	( aSymbol = #circle ) ifTrue: [ cell setCircle ] ifFalse: [ cell setCross ].
	movesCount := movesCount + 1.
	"Every time we make a move, we check to see if a winner is already decided"
	self checkWinnerAtRow: coordsArray first column: coordsArray second matrix: matrix.
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3BasicBoard methodsFor: 'public' stamp: 'JonathanOsting 7/23/2013 22:21'!
canMoveAt: coordsArray
	"checks to see if a move can be made at coords"
	"coords is a readStream with row is the first element and column is the second"
	coordsArray size < 2 ifTrue: [ self error: 'Invalid coords array' ].
	(coordsArray size == 2)
	ifTrue: [ ^(self at: (coordsArray first) at: (coordsArray second)) isEmpty ] 
	ifFalse: [ ^ false ].
	^ (self at: (coordsArray first) at: (coordsArray second)) canMoveAt: (coordsArray copyFrom: 3 to: coordsArray size)! !

!UT3BasicBoard methodsFor: 'printing' stamp: 'ShineLow 7/20/2013 10:44'!
getRowStrings 
	|retval rowString |
	retval := LinkedList new.
	1 to: size do: [ :row |
		rowString := WriteStream on: ( String new ).
		self printRow: row on: rowString.
		retval add: ( rowString contents ) ].
	^ retval! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:27'!
hash
	^ winner hash! !

!UT3BasicBoard methodsFor: 'public' stamp: 'JonathanOsting 7/23/2013 19:53'!
indicesDo: aBlock
	matrix transposed.
	matrix indicesDo: aBlock.! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 19:53'!
initialize
	size := 3. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 11:20'!
isFull
	^ movesCount = ( size * size )! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 12:28'!
movesCount
	^ movesCount! !

!UT3BasicBoard methodsFor: 'printing' stamp: 'JonathanOsting 7/23/2013 19:54'!
printBoardOn: aStream
	matrix transposed.
	
	matrix indicesDo: [
		:row :column | 
		
		(matrix at: row at: column) printStateOn: aStream.
		column = size
		ifTrue: [ aStream nextPutAll: '|'. aStream cr ] 
		ifFalse: [ aStream nextPutAll: '|' ]
		].
	! !

!UT3BasicBoard methodsFor: 'printing' stamp: 'JonathanOsting 7/23/2013 19:54'!
printRow: aRow on: aStream
	(matrix atRow: aRow) do: [ :cell | cell printStateOn: aStream ]
							     separatedBy: [ aStream nextPutAll: '|'  ]! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 19:55'!
resetWithSize: anInteger
	size := anInteger.
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 19:55'!
size: aSize 
	size := aSize. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3BasicBoard methodsFor: 'private' stamp: 'JonathanOsting 7/8/2013 17:41'!
state
	^ winner! !

!UT3BasicBoard methodsFor: 'private' stamp: 'Oliver 7/20/2013 15:16'!
type
	^(#basic)! !

UT3BasicBoard subclass: #UT3GomokuBoard
	instanceVariableNames: 'isFull'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3GomokuBoard commentStamp: '<historical>' prior: 0!
An UT3GomokuBoard is xxxxxxxxx.

Instance Variables
	isFull:		<Object>
	matrix:		<Object>

isFull
	- xxxxx

matrix
	- xxxxx
!

!UT3GomokuBoard class methodsFor: 'as yet unclassified' stamp: 'Oliver 7/25/2013 16:33'!
newWithSize: anInteger
	^ self new resetWithSize: anInteger! !

!UT3GomokuBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/25/2013 16:51'!
= aGomokuBoard
	^ winner = aGomokuBoard winner! !

!UT3GomokuBoard methodsFor: 'public' stamp: 'Oliver 7/26/2013 23:48'!
at: coordsArray put: aSymbol 
	| cell |
	coordsArray size ~= 2 ifTrue: [ MoveError signal: 'Invalid coords array.' ].
	self isFull ifTrue: [ MoveError signal: 'Board is full.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	cell := matrix at: coordsArray first at: coordsArray second.
	cell state = #empty ifFalse: [ MoveError signal: 'Cell already filled.' ].
	( aSymbol = #circle ) ifTrue: [ cell setCircle ] ifFalse: [ cell setCross ].
	movesCount := movesCount + 1.
	"Every time we make a move, we check to see if a winner is already decided"
	self checkWinnerAt: coordsArray.
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3GomokuBoard methodsFor: 'private' stamp: 'Oliver 7/26/2013 23:49'!
checkWinnerAt: coordsArray
	| currentWinner diagonal |
	winner = #undecided ifFalse: [ ^nil ].
	coordsArray size ~= 2 ifTrue: [ self error ].
	"Row"
	currentWinner := self checkWinnerOver: (matrix atRow: coordsArray first).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Col"
	currentWinner := self checkWinnerOver: (matrix atColumn: coordsArray second).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Right Diag"
	diagonal := self getRightDiagonalAt: coordsArray.
	currentWinner := self checkWinnerOver: diagonal.
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Left Diag"
	diagonal := self getLeftDiagonalAt: coordsArray.
	currentWinner := self checkWinnerOver: diagonal.
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
! !

!UT3GomokuBoard methodsFor: 'private' stamp: 'Oliver 7/27/2013 00:09'!
checkWinnerOver: anArray
	| aState aCount |
	aCount := 1. aState := nil.
	anArray do: [ :aCell | 
		aCell isEmpty 
		ifTrue: [ aCount := 1 ] 
		ifFalse: [
			(aState = aCell state) 
			ifTrue: [ aCount := aCount + 1 ]
			ifFalse: [
				aState := aCell state.
				aCount := 1.
				]
		].
		aCount > 4 ifTrue: [ ^aState ]
	].
	^ #none.
! !

!UT3GomokuBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/26/2013 23:50'!
getLeftDiagonalAt: coordsArray
	| aRow aCol diagonal aCell|
	aRow := coordsArray first. aCol := coordsArray second.
	aCell := (matrix at: aRow at: aCol).
	diagonal := LinkedList new.
	[ aCell == nil ] whileFalse: [
		diagonal addFirst: aCell.
		aRow := aRow - 1. aCol := aCol - 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	aRow := coordsArray first + 1. aCol := coordsArray second + 1.
	aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	[ aCell == nil ] whileFalse: [
		diagonal addLast: aCell.
		aRow := aRow + 1. aCol := aCol + 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	^ diagonal ! !

!UT3GomokuBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/26/2013 23:50'!
getRightDiagonalAt: coordsArray
	| aRow aCol diagonal aCell|
	aRow := coordsArray first. aCol := coordsArray second.
	aCell := (matrix at: aRow at: aCol).
	diagonal := LinkedList new.
	[ aCell == nil ] whileFalse: [
		diagonal addFirst: aCell.
		aRow := aRow - 1. aCol := aCol + 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	aRow := coordsArray first + 1. aCol := coordsArray second - 1.
	aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	[ aCell == nil ] whileFalse: [
		diagonal addLast: aCell.
		aRow := aRow + 1. aCol := aCol - 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	^ diagonal ! !

!UT3GomokuBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/26/2013 23:09'!
initialize
	size := 19. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winningCount := 5.
	winner := #undecided.! !

!UT3GomokuBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/26/2013 23:08'!
resetWithSize: anInteger
	size := anInteger.
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winningCount := 5.
	winner := #undecided.! !

!UT3GomokuBoard methodsFor: 'private' stamp: 'Oliver 7/26/2013 23:08'!
size: aSize 
	size := aSize. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winningCount := 5.
	winner := #undecided.! !

!UT3GomokuBoard methodsFor: 'private' stamp: 'Oliver 7/25/2013 16:34'!
type
	^(#gomoku)! !

UT3BasicBoard subclass: #UT3RecursiveNestedBoard
	instanceVariableNames: 'movesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3RecursiveNestedBoard commentStamp: '<historical>' prior: 0!
An UT3RecursiveNestedBoard is xxxxxxxxx.

Instance Variables
	boardMatrix:		<Object>
	movesList:		<Object>

boardMatrix
	- xxxxx

movesList
	- xxxxx
!

UT3RecursiveNestedBoard subclass: #UT3DoubleNestedBoard
	instanceVariableNames: 'movesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3DoubleNestedBoard commentStamp: '<historical>' prior: 0!
An UT3DoubleNestedBoard is xxxxxxxxx.

Instance Variables
	boardMatrix:		<Object>
	movesList:		<Object>

boardMatrix
	- xxxxx

movesList
	- xxxxx
!

!UT3DoubleNestedBoard methodsFor: 'action' stamp: 'JonathanOsting 7/23/2013 21:47'!
at: aRow at: aCol	
	^ matrix at: aRow at: aCol.
! !

!UT3DoubleNestedBoard methodsFor: 'action' stamp: 'JonathanOsting 7/23/2013 22:56'!
at: coordsArray put: aSymbol
	| subBoard|	
	coordsArray size ~= 6 ifTrue: [ MoveError signal: 'Invalid coords array.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	subBoard := matrix at: (coordsArray first) at: (coordsArray second).
	subBoard isFull ifTrue: [ MoveError signal: 'Subboard already full' ].
	(self canMoveAt: coordsArray) ifFalse: [ MoveError signal: 'Subboard cell filled' ].
	subBoard at: (coordsArray copyFrom: 3 to: coordsArray size) put: aSymbol.
	movesCount := movesCount + 1.
	"movesList add: { anArray. subArray }."
	movesList add: coordsArray.
	"Every time we make a move, we check to see if a winner is already decided"	
	( (subBoard winner = #cross) | (subBoard winner = #circle) ) ifTrue: [ 
		self checkWinnerAtRow: (coordsArray first) column: (coordsArray second) matrix: matrix ].
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3DoubleNestedBoard methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/23/2013 22:41'!
canMoveAt: coordsArray
	"A move is valid if only the current coordinate is the same as the previous subArray coordinate.
	If the target board is already full, then the move is valid at any location."
	| row column lastMove lastRow lastCol |
	(movesList size = 0) ifTrue: [ ^ true ].
	row := coordsArray first. column := coordsArray second.
	row > size ifTrue: [ self error: 'Row index is greater than board size!!' ].
	column > size ifTrue: [ self error: 'Row index is greater than board size!!' ].
	lastMove := (movesList last).
	lastRow := lastMove at: (lastMove size) - 1.
	lastCol := lastMove last.
	(row = lastRow & column = lastCol)
	ifTrue: [ ^ (self at: row at: column) canMoveAt: (coordsArray copyFrom: 3 to: coordsArray size) ]
	ifFalse: [ (matrix at: lastRow at: lastCol) isFull
			  ifTrue: [ ^ (self at: row at: column) canMoveAt: (coordsArray copyFrom: 3 to: coordsArray size) ] ].
	^ false! !

!UT3DoubleNestedBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 21:47'!
initialize
	size := 3. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3RecursiveNestedBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3DoubleNestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 21:48'!
isFull
	matrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	^ true! !

!UT3DoubleNestedBoard methodsFor: 'printing' stamp: 'JonathanOsting 7/23/2013 21:48'!
printBoardOn: aStream
	
	|subBoardSize|
	subBoardSize := (matrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(matrix at: row at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream cr.  ].
			aStream cr.
		].
		aStream cr.
	].

! !

!UT3DoubleNestedBoard methodsFor: 'printing' stamp: 'JonathanOsting 7/23/2013 21:48'!
printRow: aRow on: aStream
	matrix do: [ :subBoard | subBoard printRow: aRow on: aStream ].! !

!UT3DoubleNestedBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 21:48'!
resetWithSize: anInteger
	size := anInteger. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3RecursiveNestedBoard newWithSize: anInteger ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3DoubleNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:05'!
winner
	^ winner! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 19:57'!
at: aRow at: aColumn
	^ matrix at: aRow at: aColumn! !

!UT3RecursiveNestedBoard methodsFor: 'action' stamp: 'JonathanOsting 7/23/2013 22:54'!
at: coordsArray put: aSymbol
	| subBoard |
	coordsArray size ~= 4 ifTrue: [ MoveError signal: 'Invalid coords array.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	subBoard := matrix at: (coordsArray first) at: (coordsArray second).
	subBoard isFull ifTrue: [ MoveError signal: 'Subboard already full' ].
	(self canMoveAt: coordsArray) ifFalse: [ MoveError signal: 'Subboard cell filled' ].
	"(subBoard canMoveAtRow: subRow column: subColumn) ifFalse: [ MoveError signal: 'Subboard cell filled' ]."
	"self at: coordsArray put: aSymbol."
	subBoard at: (coordsArray copyFrom: 3 to: coordsArray size) put: aSymbol.
	movesCount := movesCount + 1.
	"movesList add: { anArray. subArray }."
	movesList add: coordsArray.
	"Every time we make a move, we check to see if a winner is already decided"	
	( (subBoard winner = #cross) | (subBoard winner = #circle) ) ifTrue: [ 
		self checkWinnerAtRow: (coordsArray first) column: (coordsArray second) matrix: matrix ].
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3RecursiveNestedBoard methodsFor: 'action' stamp: 'JonathanOsting 7/23/2013 22:52'!
canMoveAt: coordsArray
	"A move is valid if only the current coordinate is the same as the previous subArray coordinate.
	If the target board is already full, then the move is valid at any location."
	| row column lastMove lastRow lastCol |
	(movesList size = 0) ifTrue: [ ^ true ].
	row := coordsArray first. column := coordsArray second.
	row > size ifTrue: [ self error: 'Row index is greater than board size!!' ].
	column > size ifTrue: [ self error: 'Row index is greater than board size!!' ].
	lastMove := (movesList last).
	lastRow := lastMove at: (lastMove size) - 1.
	lastCol := lastMove last.
	(row = lastRow & column = lastCol)
	ifTrue: [ ^ (self at: row at: column) canMoveAt: (coordsArray copyFrom: 3 to: coordsArray size) ]
	ifFalse: [ (matrix at: lastRow at: lastCol) isFull
			  ifTrue: [ ^ (self at: row at: column) canMoveAt: (coordsArray copyFrom: 3 to: coordsArray size) ] ].
	^ false! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 19:58'!
indicesDo: aBlock
	matrix indicesDo: aBlock.! !

!UT3RecursiveNestedBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 19:58'!
initialize
	size := 3. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 19:59'!
isFull
	matrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	^ true! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 19:59'!
printBoardOn: aStream
	|subBoardSize|
	subBoardSize := (matrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(matrix at: row at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream nextPutAll: ' || '  ].
			aStream cr.
		].
		aStream cr.
	].! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 19:59'!
printRow: aRow on: aStream

	|subBoardSize|
	subBoardSize := (matrix at: 1 at: 1) size.
	aStream nextPutAll: ' ||| '.
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(matrix at: aRow at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream nextPutAll: ' || '  ].
			 aStream nextPutAll: ' ||| '.
		].

	"boardMatrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	(cellMatrix atRow: aRow) do: [ :cell | cell printStateOn: aStream ]
							     separatedBy: [ aStream nextPutAll: '|'  ]"! !

!UT3RecursiveNestedBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 19:59'!
resetWithSize: anInteger
	size := anInteger. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard newWithSize: anInteger ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:31'!
winner
	^ winner! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 23:05'!
at: aRow at: aCol
	"provide access to the underlying matrix"
	^ matrix at: aRow at: aCol! !

!UT3Board methodsFor: 'action' stamp: 'JonathanOsting 7/8/2013 16:11'!
at: coordsArray put: aSymbol
	^ self subclassResponsibility ! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/23/2013 21:18'!
canMoveAt: coordsArray
	^ self subclassResponsibility.! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:29'!
checkWinnerAtRow: aRow column: aColumn matrix: aMatrix
	|currentWinner diagonalSet|
	winner = #undecided ifFalse: [ ^nil ].
	"Check current row"
	currentWinner := self getWinnerAtSet: ( (aMatrix atRow: aRow) asSet ).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Check current column"
	currentWinner := self getWinnerAtSet: ( ( aMatrix atColumn: aColumn ) asSet).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Check diagonals, from top left to bottom right"
	diagonalSet := Set new.
	aRow = aColumn ifTrue:[
		1 to: size do: [ :index | diagonalSet add: ( aMatrix at: index at: index ) ].
		currentWinner := self getWinnerAtSet: diagonalSet.
		currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ]
		].
	"From bottom left to top right"
	diagonalSet := Set new.
	aRow = ( size - aColumn + 1 ) ifTrue: [ 
		1 to: size do: [ :index | diagonalSet add: ( aMatrix at: index at: ( size - index + 1 ) ) ]	.
		currentWinner := self getWinnerAtSet: diagonalSet.
		currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ]
	]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/20/2013 22:15'!
checkWinningWithCol: subMatrix

	| retArray |
	retArray := Array new: ( size).

	1 to: ( size) do: [ :i| 
		retArray at: i put: (self checkWinningWithSet: ((subMatrix atColumn: i) asSet)).
		 ].

	retArray do: [ :x| 
		(x > 0)
		ifTrue: [ ^x ]
		 ].
	
	^0.! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/20/2013 21:59'!
checkWinningWithDiagonal: subMatrix

	| ret1 ret2 tempSet |
	tempSet := Set new.
	
	1 to: ( size) do: [ :i |
			tempSet add: (subMatrix at: i at: ( ( size) + 1 - i ) )
		].		
	
	ret1 := (self checkWinningWithSet: ((subMatrix diagonal) asSet)).
	ret2 := (
		self checkWinningWithSet: tempSet
	).
	
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[^0]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/20/2013 22:15'!
checkWinningWithRow: subMatrix

	| retArray |
	retArray := Array new: ( size).

	1 to: ( size) do: [ :i| 
		 retArray at: i put: (self checkWinningWithSet: ((subMatrix atRow: i) asSet)).
		 ].
	
	retArray do: [ :x| 
		(x > 0)
		ifTrue: [ ^x ]
		 ].
	
	^0.
! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:32'!
checkWinningWithSet: aSet

	|  |
	(aSet size = 1)
	ifTrue:["judge"
		(aSet includes: 1)
		ifTrue:[ ^1 ]
		ifFalse:[
			(aSet includes: 2)
				ifTrue:[ ^2 ]
				ifFalse:[ ^0 ].
			]
		]
	ifFalse:[^0]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/20/2013 22:16'!
checkWinningWithSubMatrix: subMatrix

	| retArray |
	retArray := Array new: (3).
	
	retArray at: 1 put: (self checkWinningWithRow: subMatrix).
	retArray at: 2 put: (self checkWinningWithCol: subMatrix).
	retArray at: 3 put:(self checkWinningWithDiagonal: subMatrix).

	retArray do: [ :x| 
		(x > 0)
		ifTrue: [ ^x ]
		 ].
	
	^0.! !

!UT3Board methodsFor: 'printing' stamp: 'ShineLow 7/20/2013 10:41'!
getRowStrings
	^ self subclassResponsibility ! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:25'!
getWinnerAtSet: aSet
	|winnerCell|
	(aSet size = 1) ifFalse: [ ^#none ].
	winnerCell := aSet atRandom.
	(winnerCell state = #empty | winnerCell state = #undecided) ifTrue: [ ^#none ] ifFalse: [ ^ winnerCell state ]! !

!UT3Board methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 17:09'!
initialize 
	^ self subclassResponsibility! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 00:08'!
movesCount
	^ movesCount! !

!UT3Board methodsFor: 'action' stamp: 'JonathanOsting 7/8/2013 16:33'!
player: aPlayer moveRow: aMoveRow moveCol: aMoveCol
	|symbol row column subRow subColumn|
	aPlayer = 1 ifTrue: [ symbol := #circle ] ifFalse: [ symbol := #cross ].
	row := (aMoveRow / size) asFraction ceiling.
	column := ( aMoveCol / size ) asFraction ceiling.
	subRow := aMoveRow % size.
	(subRow = 0) ifTrue: [ subRow := size ].
	subColumn := aMoveCol % size.
	( subColumn = 0 ) ifTrue: [ subColumn := size ].
	self at: { row. column . subRow. subColumn } put: symbol! !

!UT3Board methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 14:39'!
printBoardOn: aStream
	^ self subclassResponsibility ! !

!UT3Board methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 14:39'!
printBoardString
	|stream|
	stream := WriteStream on: ( String new ).
	self printBoardOn: stream.
	^ stream contents! !

!UT3Board methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 16:57'!
printOn: aStream
	" prints the gameboard on a stream"
	self printBoardOn: aStream! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 17:15'!
size
	^ size! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/22/2013 20:57'!
winner
	^winner! !

UT3Board subclass: #UT3Connect4Board
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Connect4Board commentStamp: '<historical>' prior: 0!
An UT3Connect4Board is connect 4 board.

The goal is to have the board use the same underlying system as for tic-tac-toe, but with a different board shape (non-square), different winning condition, and different way of making moves.

Instance Variables
!

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/22/2013 22:54'!
at: aCol put: aSymbol
	| aRow cell |
	self isFull ifTrue: [ MoveError signal: 'Board is full.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	aRow := ( matrix atColumn: aCol ) findLast: [ :aCell | aCell isEmpty ].
	aRow = 0 ifTrue: [ MoveError signal: 'No empty cells. Column is full.' ].
	cell := matrix at: aRow at: aCol.
	( aSymbol = #circle ) ifTrue: [ cell setCircle ] ifFalse: [ cell setCross ].
	movesCount := movesCount + 1.
	"Every time we make a move, we check to see if a winner is already decided"
	self checkWinnerAt: { aRow . aCol }.
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/22/2013 21:59'!
canMoveAt: aCol
	"checks to see if a move can be made at a given column"
	^(Set newFrom: (matrix atColumn: aCol)) includes: UT3Cell new! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:35'!
checkWinnerAt: coordsArray
	| currentWinner diagonal |
	winner = #undecided ifFalse: [ ^nil ].
	coordsArray size ~= 2 ifTrue: [ self error ].
	"Row"
	currentWinner := self checkWinnerOver: (matrix atRow: coordsArray first).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Col"
	currentWinner := self checkWinnerOver: (matrix atColumn: coordsArray second).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Right Diag"
	diagonal := self getRightDiagonalAt: coordsArray.
	currentWinner := self checkWinnerOver: diagonal.
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Left Diag"
	diagonal := self getLeftDiagonalAt: coordsArray.
	currentWinner := self checkWinnerOver: diagonal.
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 21:59'!
checkWinnerOver: anArray
	| aState aCount |
	aCount := 1. aState := nil.
	anArray do: [ :aCell | 
		aCell isEmpty ifTrue: [ aCount := 1 ] 
		ifFalse: [
			(aState = aCell state) ifTrue: [ aCount := aCount + 1 ].
			aState := aCell state.
		].
		aCount > 3 ifTrue: [ ^aState ]
	].
	^ #none.
! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:40'!
getLeftDiagonalAt: coordsArray
	| aRow aCol diagonal aCell|
	aRow := coordsArray first. aCol := coordsArray second.
	aCell := (matrix at: aRow at: aCol).
	diagonal := LinkedList new.
	[ aCell == nil ] whileFalse: [
		diagonal addFirst: aCell.
		aRow := aRow - 1. aCol := aCol - 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	aRow := coordsArray first + 1. aCol := coordsArray second + 1.
	aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	[ aCell == nil ] whileFalse: [
		diagonal addLast: aCell.
		aRow := aRow + 1. aCol := aCol + 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	^ diagonal ! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:40'!
getRightDiagonalAt: coordsArray
	| aRow aCol diagonal aCell|
	aRow := coordsArray first. aCol := coordsArray second.
	aCell := (matrix at: aRow at: aCol).
	diagonal := LinkedList new.
	[ aCell == nil ] whileFalse: [
		diagonal addFirst: aCell.
		aRow := aRow - 1. aCol := aCol + 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	aRow := coordsArray first + 1. aCol := coordsArray second - 1.
	aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	[ aCell == nil ] whileFalse: [
		diagonal addLast: aCell.
		aRow := aRow + 1. aCol := aCol - 1.
		aCell := (matrix at: aRow at: aCol ifInvalid: nil).
	].
	^ diagonal ! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 22:52'!
indicesDo: aBlock
	matrix indicesDo: aBlock.! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 00:21'!
initialize
	size := Array with: 4 with: 7. "Default board size is 4x7"
	matrix := Matrix rows: size first columns: size second tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/24/2013 00:09'!
isFull
	^ movesCount = ( size first * size second )! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/22/2013 22:53'!
printBoardOn: aStream
	matrix indicesDo: [
		:row :column | 
		
		(matrix at: row at: column) printStateOn: aStream.
		column = size second
		ifTrue: [ aStream nextPutAll: '|'. aStream cr ] 
		ifFalse: [ aStream nextPutAll: '|' ]
		].
	! !

!UT3Connect4Board methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/22/2013 20:58'!
type
	^(#connect4)! !

UT3Board subclass: #UT3NestedBoard
	instanceVariableNames: 'movesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3NestedBoard commentStamp: '<historical>' prior: 0!
An UT3NestedBoard is a TicTacToe Board that implements the Ultimate Tic Tac Toe game. It holds a matrix of regular TicTacToe boards, and each move will need to specify column and row of both the larger board and smaller board.

Instance Variables
	boardMatrix:		<Object>

boardMatrix
	- xxxxx
!

!UT3NestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 21:49'!
at: aRow at: aColumn
	^ matrix at: aRow at: aColumn! !

!UT3NestedBoard methodsFor: 'action' stamp: 'Oliver 7/25/2013 19:49'!
at: coordsArray put: aSymbol
	| subBoard |
	coordsArray size ~= 4 ifTrue: [ MoveError signal: 'Invalid coords array.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	subBoard := matrix at: (coordsArray first) at: (coordsArray second).
	subBoard isFull ifTrue: [ MoveError signal: 'Subboard already full' ].
	(self canMoveAt: coordsArray) ifFalse: [ MoveError signal: 'Illegal Move' ].
	"(subBoard canMoveAtRow: subRow column: subColumn) ifFalse: [ MoveError signal: 'Subboard cell filled' ]."
	"self at: coordsArray put: aSymbol."
	subBoard at: (coordsArray copyFrom: 3 to: (coordsArray size) ) put: aSymbol.
	movesCount := movesCount + 1.
	"movesList add: { anArray. subArray }."
	movesList add: coordsArray.
	"Every time we make a move, we check to see if a winner is already decided"	
	( (subBoard winner = #cross) | (subBoard winner = #circle) ) ifTrue: [ 
		self checkWinnerAtRow: (coordsArray first) column: (coordsArray second) matrix: matrix ].
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3NestedBoard methodsFor: 'action' stamp: 'JonathanOsting 7/23/2013 22:25'!
canMoveAt: coordsArray
	"A move is valid if only the current coordinate is the same as the previous subArray coordinate.
	If the target board is already full, then the move is valid at any location."	
	| row column lastMove lastRow lastCol |
	(movesList size = 0) ifTrue: [ ^ true ].
	row := coordsArray first. column := coordsArray second.
	row > size ifTrue: [ self error: 'Row index is greater than board size!!' ].
	column > size ifTrue: [ self error: 'Row index is greater than board size!!' ].
	lastMove := (movesList last).
	lastRow := lastMove at: (lastMove size) - 1.
	lastCol := lastMove last.
	(row = lastRow & column = lastCol)
	ifTrue: [ ^ (self at: row at: column) canMoveAt: (coordsArray copyFrom: 3 to: coordsArray size) ]
	ifFalse: [ (matrix at: lastRow at: lastCol) isFull
			  ifTrue: [ ^ (self at: row at: column) canMoveAt: (coordsArray copyFrom: 3 to: coordsArray size) ] ].
	^ false! !

!UT3NestedBoard methodsFor: 'printing' stamp: 'JonathanOsting 7/25/2013 21:29'!
getRowStrings 
	|retval rowString subBoardSize subBoard |
	retval := LinkedList new.
	subBoardSize := (matrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			rowString := WriteStream on: ( String new ).
			(1 to: size) do: [ :column |
				subBoard := matrix at: row at: column.
				subBoard printRow: subRow on: rowString
				] separatedBy: [ rowString nextPutAll: ' || ' ].
			retval add: ( rowString contents )
		 ].
	       retval add: ''
	  ].
	^ retval! !

!UT3NestedBoard methodsFor: 'enumerating' stamp: 'JonathanOsting 7/6/2013 06:41'!
indicesDo: aBlock
	boardMatrix indicesDo: aBlock.! !

!UT3NestedBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 21:54'!
initialize
	size := 3. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3NestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/23/2013 21:54'!
isFull
	matrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	^ true! !

!UT3NestedBoard methodsFor: 'printing' stamp: 'JonathanOsting 7/23/2013 22:59'!
printBoardOn: aStream
	|subBoardSize|
	subBoardSize := (matrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(matrix at: row at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream nextPutAll: ' || '  ].
			aStream nextPutAll: ' || '.
			aStream cr.
		].
		aStream cr.
	].! !

!UT3NestedBoard methodsFor: 'initialize-release' stamp: 'JonathanOsting 7/23/2013 21:54'!
resetWithSize: anInteger
	size := anInteger. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard newWithSize: anInteger ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3NestedBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/27/2013 08:27'!
size: aSize
	size := aSize. "Default board size is 3x3"
	matrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3NestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/20/2013 15:16'!
type
	^(#nested)! !

Object subclass: #UT3Cell
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Cell commentStamp: '<historical>' prior: 0!
An UT3Cell is class representing a Cell in a Board.

Instance Variables
	state:		<Object>

state
	- xxxxx
!

!UT3Cell methodsFor: 'comparing' stamp: 'ShineLow 7/4/2013 11:23'!
= aCell
	^ state = aCell state! !

!UT3Cell methodsFor: 'comparing' stamp: 'ShineLow 7/4/2013 12:16'!
hash
	^ state hash! !

!UT3Cell methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 10:18'!
initialize
	state := #empty! !

!UT3Cell methodsFor: 'accessing' stamp: 'Oliver 7/26/2013 23:56'!
isEmpty
	^ ((state = #empty) | (state = nil) )! !

!UT3Cell methodsFor: 'printing' stamp: 'JonathanOsting 7/22/2013 22:57'!
printOn: aStream
	aStream nextPutAll: 'Cell with '.
	state = #empty ifTrue: [ aStream nextPutAll: 'nothing' ]
					 ifFalse: [ state = #circle ifTrue: [ aStream nextPutAll: '0' ]
											  ifFalse: [ aStream nextPutAll: 'x' ] ]! !

!UT3Cell methodsFor: 'printing' stamp: 'JonathanOsting 7/22/2013 22:56'!
printStateOn: aStream 
		state = #empty ifTrue: [ aStream nextPutAll: ' _ ' ]
					 ifFalse: [ state = #circle ifTrue: [ aStream nextPutAll: ' 0 ' ]
											  ifFalse: [ aStream nextPutAll: ' x ' ] ]! !

!UT3Cell methodsFor: 'printing' stamp: 'JonathanOsting 7/24/2013 23:15'!
printString
	" return a string representing the cell"
	state = #empty ifTrue: [ ^ ' _ ' ]
					 ifFalse: [ state = #circle ifTrue: [ ^ ' o ' ]
											  ifFalse: [ ^ ' x ' ] ]! !

!UT3Cell methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 10:24'!
setCircle
	state = #empty ifFalse: [ MoveError signal ].
	state := #circle! !

!UT3Cell methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 10:25'!
setCross
	state = #empty ifFalse: [ MoveError signal ].
	state := #cross! !

!UT3Cell methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 10:22'!
state
	^ state! !

Object subclass: #UT3System
	instanceVariableNames: 'board currentPlayer gameTypes currentGameType ai'
	classVariableNames: 'MaxPlayers PlayerIcons'
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3System commentStamp: '<historical>' prior: 0!
An UT3System is the class encapsulating an entire Ultimate TicTacToe game.

It contains an interface to make moves for each player, and holds an instance of UT3Board that represents the game board state, and is stateful in the sense that it records each player's move.

You can use the provided API to get the which player's turn it is, etc. Invalid moves will throw MoveError.

Instance Variables
!

!UT3System class methodsFor: 'class initialization' stamp: 'ShineLow 7/4/2013 18:55'!
initialize 
	super initialize.
	MaxPlayers := 2.
	PlayerIcons := Dictionary newFrom: { 1->#circle. 2->#cross }! !

!UT3System class methodsFor: 'instance creation' stamp: 'ShineLow 7/4/2013 19:12'!
new
	MaxPlayers isNil ifTrue: [ self initialize ].
	^ self basicNew initialize.! !

!UT3System methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 19:55'!
board
	^board.! !

!UT3System methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 19:56'!
board: aBoard
	board := aBoard.! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 19:00'!
currentGameType
	^ currentGameType! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:18'!
currentGameType: aGameType
	self resetWithGameType: aGameType asSymbol! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 19:00'!
currentPlayer
	^ currentPlayer! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 19:00'!
gameTypes
	^ gameTypes! !

!UT3System methodsFor: 'initialize-release' stamp: 'Oliver 7/25/2013 16:22'!
initialize
	board := UT3BasicBoard new.
	currentPlayer := 1.
	gameTypes := { #basic. #medium. #large. #huge. #gigantic. #enormous. #gomoku. #ultimate. #double_ultimate. #connect4 }.
	currentGameType := #basic.
	ai := nil.! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/12/2013 22:01'!
isGameOver
	^ (board winner = #cross) | ( board winner = #circle ) | ( board winner = #none)! !

!UT3System methodsFor: 'actions' stamp: 'JonathanOsting 7/23/2013 22:29'!
player: aPlayer moveAt: coordsArray
	currentPlayer = aPlayer ifFalse: [ SystemError signal: 'Not this players turn' ].
	"currentGameType = #ultimate ifFalse: [ SystemError signal: 'Only ultimate gametype supports this move!!' ]."
	(board canMoveAt: coordsArray)
	ifTrue: [ board at: coordsArray put: (PlayerIcons at: currentPlayer).
   			 currentPlayer := currentPlayer % MaxPlayers + 1 ]
	ifFalse: [ SystemError signal: 'Cannot move there!!' ].
	
	(ai = nil) ifFalse: [ ai move. currentPlayer := currentPlayer % MaxPlayers + 1 ]! !

!UT3System methodsFor: 'actions' stamp: 'JonathanOsting 7/25/2013 21:43'!
player: aPlayer moveAt: anArray subBoard: anArray2
	| coordsArray | 
	coordsArray := { anArray first. anArray second. anArray2 first. anArray2 second}.
	currentPlayer = aPlayer ifFalse: [ SystemError signal: 'Not this players turn' ].
	currentGameType = #ultimate ifFalse: [ SystemError signal: 'Only ultimate gametype supports this move!!' ].
	(board canMoveAt: coordsArray)
	ifTrue: [ board at: coordsArray put: (PlayerIcons at: currentPlayer).
   			 currentPlayer := currentPlayer % MaxPlayers + 1 ]
	ifFalse: [ SystemError signal: 'Cannot move there!!' ].
	
	(ai = nil) ifFalse: [ ai move. currentPlayer := currentPlayer % MaxPlayers + 1 ]! !

!UT3System methodsFor: 'actions' stamp: 'JonathanOsting 7/8/2013 16:36'!
player: aPlayer moveAt: anArray subBoard: anArray2 ssubBoard: anArray3
	| coordsArray | 
	coordsArray := {anArray first.   anArray second. 
					  anArray2 first. anArray2 second.
					  anArray3 first. anArray3 second}.
	currentPlayer = aPlayer ifFalse: [ SystemError signal: 'Not this players turn' ].
	currentGameType = #double_ultimate ifFalse: [ SystemError signal: 'Only double_ultimate gametype supports this move!!' ].
	(board canMoveAt: coordsArray readStream)
	ifTrue: [ board at: coordsArray put: (PlayerIcons at: currentPlayer).
   			 currentPlayer := currentPlayer % MaxPlayers + 1 ]
	ifFalse: [ SystemError signal: 'Cannot move there!!' ].! !

!UT3System methodsFor: 'actions' stamp: 'JonathanOsting 7/25/2013 21:32'!
player: aPlayer moveRow: aRow column: aColumn 
	| coordsArray |
	coordsArray := { aRow. aColumn }.
	currentPlayer = aPlayer ifFalse: [ SystemError signal: 'Not this players turn' ].
	( (currentGameType = #ultimate ) | (currentGameType = #double_ultimate ) ) ifTrue: [ SystemError signal: 'Only none ultimate gametype supports this move!!' ].
	(board canMoveAt: coordsArray)
	ifTrue: [ board at: coordsArray put: ( PlayerIcons at: currentPlayer ).
          		 currentPlayer := currentPlayer % MaxPlayers + 1]
	ifFalse: [ SystemError signal: 'Cannot move there!!' ].
	
	(ai = nil) ifFalse: [ ai move. currentPlayer := currentPlayer % MaxPlayers + 1 ]! !

!UT3System methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 20:44'!
printOn: aStream 
	aStream nextPutAll: 'Current Game Type: '.
	currentGameType printOn: aStream.
	aStream cr; nextPutAll: 'Current player: '.
	currentPlayer printOn: aStream.
	aStream cr; nextPutAll: 'Current board state: '.
	board winner printOn: aStream.
	aStream cr. board printBoardOn: aStream.! !

!UT3System methodsFor: 'actions' stamp: 'Oliver 7/26/2013 23:01'!
resetWithGameType: aSymbol
	(gameTypes includes: aSymbol) ifFalse: [ SystemError signal: 'Unknown game type' ].
	aSymbol = #basic ifTrue: [ self initialize. currentGameType := aSymbol. ].
	aSymbol = #medium ifTrue: [ self initialize. board := UT3BasicBoard new. board size: 5. currentGameType := aSymbol. ].
	aSymbol = #large ifTrue: [ self initialize. board := UT3BasicBoard new. board size: 7. currentGameType := aSymbol. ].
	aSymbol = #huge ifTrue: [ self initialize. board := UT3BasicBoard new. board size: 9. currentGameType := aSymbol. ].
	aSymbol = #gigantic ifTrue: [ self initialize. board := UT3BasicBoard new. board size: 11. currentGameType := aSymbol. ].
	aSymbol = #enormous ifTrue: [ self initialize. board := UT3BasicBoard new. board size: 15. currentGameType := aSymbol. ].
	aSymbol = #gomoku ifTrue: [ self initialize. board := UT3GomokuBoard new. board initialize. currentGameType := aSymbol. ].
	aSymbol = #ultimate ifTrue: [ self initialize. board := UT3NestedBoard new. currentGameType := aSymbol. ].
	aSymbol = #double_ultimate ifTrue: [ self initialize. board := UT3DoubleNestedBoard new. currentGameType := aSymbol. ].
	aSymbol = #connect4 ifTrue: [ self initialize. board := UT3Connect4Board new. currentGameType := aSymbol. ].
! !

!UT3System methodsFor: 'actions' stamp: 'Oliver 7/27/2013 08:01'!
resetWithGameType: aSymbol ai: anAiSymbol
	(gameTypes includes: aSymbol) ifFalse: [ SystemError signal: 'Unknown game type' ].
	aSymbol = #basic ifTrue: [ 
		self initialize. 
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] .
		anAiSymbol = #easy ifTrue: [ ai := UT3EasyAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3MedAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3HardAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3InsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3PerfectAI newWith: board as: (PlayerIcons at: 2) ]
		].
	aSymbol = #medium ifTrue: [ 
		self initialize. 
		board := UT3BasicBoard new.
		board size: 5.
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] .
		anAiSymbol = #easy ifTrue: [ ai := UT3EasyAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3MedAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3HardAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3InsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3PerfectAI newWith: board as: (PlayerIcons at: 2) ]
		].
	aSymbol = #large ifTrue: [ 
		self initialize. 
		board := UT3BasicBoard new.
		board size: 7.
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] .
		anAiSymbol = #easy ifTrue: [ ai := UT3EasyAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3MedAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3HardAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3InsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3PerfectAI newWith: board as: (PlayerIcons at: 2) ]
		].
	aSymbol = #huge ifTrue: [ 
		self initialize. 
		board := UT3BasicBoard new.
		board size: 9.
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] .
		anAiSymbol = #easy ifTrue: [ ai := UT3EasyAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3MedAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3HardAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3InsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3PerfectAI newWith: board as: (PlayerIcons at: 2) ]
		].
	aSymbol = #gigantic ifTrue: [ 
		self initialize. 
		board := UT3BasicBoard new.
		board size: 11.
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] .
		anAiSymbol = #easy ifTrue: [ ai := UT3EasyAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3MedAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3HardAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3InsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3PerfectAI newWith: board as: (PlayerIcons at: 2) ]
		].
	aSymbol = #enormous ifTrue: [ 
		self initialize. 
		board := UT3BasicBoard new.
		board size: 15.
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] .
		anAiSymbol = #easy ifTrue: [ ai := UT3EasyAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3MedAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3HardAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3InsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3PerfectAI newWith: board as: (PlayerIcons at: 2) ]
		].
	
	aSymbol = #gomoku ifTrue: [ 
		self initialize. 
		board := UT3GomokuBoard new.
		board initialize. 
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] .
		anAiSymbol = #easy ifTrue: [ ai := UT3EasyAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3MedAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3HardAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3InsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3PerfectAI newWith: board as: (PlayerIcons at: 2) ]
		].
	
	aSymbol = #ultimate ifTrue: [
		self initialize.
		board := UT3NestedBoard new.
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3NestedRandomAI newWith: board as: ( PlayerIcons at: 2 ) ].
		anAiSymbol = #easy ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3NestedInsaneAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ]
		 ].
	aSymbol = #double_ultimate ifTrue: [ 
		self initialize. 
		board := UT3DoubleNestedBoard new. 
		currentGameType := aSymbol.
		anAiSymbol = #random ifTrue: [ ai := UT3NestedRandomAI newWith: board as: ( PlayerIcons at: 2 ) ].
		anAiSymbol = #easy ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #med ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #hard ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #insane ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ].
		anAiSymbol = #perfect ifTrue: [ ai := UT3NestedRandomAI newWith: board as: (PlayerIcons at: 2) ]
		].
! !
UT3System initialize!
